//
//  NNTPEnums.h
//  UsenetEngine
//
//  Created by Ger Teunis on 12/28/09.
//  Copyright 2010 Ger Teunis. All rights reserved.
//

//#define MAC_APP_STORE
#define NETWORK_READ_SIZE 8*1024
#define NETWORK_READ_SIZE_SMALL 1024
#define NETWORK_READ_SIZE_TINY 512
#define NETWORK_ARTICLE_SIZE 1*1024*1024
#define NETWORK_RETRY_DELAY 60
#define NETWORK_RETRY_DELAY_ERROR 60
#define MOVE_BUFFER_LENGTH 512*1024
#define UNREGISTERED_CONNECTION_NUMBER 2
#define PARTIAL_SUFFIX ".partial"
#define SQLITE_STATEFILE
#define MAX_THREADSTOP_WAIT 10
#define FREE_TRIAL_DAYS 7
#define FREE_TRIAL_UPDATE_TIME_HRS 1
#define GENERAL_SLEEP_INTERVAL 1
#define HTTP_FILE_DOWNLOAD_TIMEOUT 30
#define HTTP_FILE_DOWNLOAD_BUFFER_SIZE 10*1024
#define RSSFEED_UPDATE_INTERVAL_MINIMAL 15*60
#define SQLITE_TRANSACTION_MAX_MANIPULATIONS 1000
#define DONT_PARSE_ZIPS_LARGER_MB 50
#define DONT_PASSWORD_CHECK_ARCHIVERS_LARGER_MB 200
#define HELPER_APP_MIN_VERSION @"1.0.0"
#define NETWORK_API_APILEVEL @"2.2"
#define MAX_SPEEDGRAPH_WIDTH 400

typedef enum {
	NNTPConnectionError = -1,
	NNTPNothingDownloaded = -2,
    NNTPConnectionErrorResumeFromSleep = -3
} NNTPResultUsenetEngineResponses;

typedef enum {
	ServerReadyPostingAllowed = 200,
	ServerReadyNoPostingAllowed = 201,
	ServiceDiscontinued = 400, //also used when connections full
	AuthenticationRequired = 480,
	CommandNotRecognized = 500,
	CommandSyntaxError = 501,
	AccessRestrictionOrPermissionDenied = 502,
	ProgramFaultCommandNotPerformed = 503,
    CannotConnectToServer = 590 //CUSTOM
} NNTPResultCodeGeneralResponses;


typedef enum {
	ArticleRetrievedHeaderBody = 220,
	ArticleRetrievedHeader = 221,
	ArticleRetrievedBody = 222,
	ArticleRetrievedTextSeperate = 223,
	NoNewsGroupSelected = 412,
	NoArticleSelected = 420,
	NoSuchArticleInGroup = 423,
	NoSuchArticleFound = 430	
} NNTPResultCodeRetrieveArticleResponses;


typedef enum {
	NewsGroupSelected = 211, 
	NoSuchNewsGroup = 411
} NNTPSelectGroupResponses;


typedef enum {
	AuthenticationAccepted = 281,
	PasswordRequired = 381,
	AuthenticationFailed = 481, //also used when connections full
	AuthenticationCommandOutOfSequence = 482,
	CommandUnavailable = 502
} NNTPResultCodeAuthResponse;

typedef enum {
    NZBStateAdding = -1,
	NZBStateWaiting = 0,
	NZBStateDownloading = 1,
	NZBStateDownloadFinished = 2,
	NZBStateSaving = 3,
	NZBStateSaved = 4,
    NZBStateWaitForPasswordEnter = 5,
	NZBStateWaitForPostProcessing = 6,
	NZBStateWaitForManualPostProcessing = 7,
	NZBStateProcessingPar = 8,
	NZBStateProcessingParRepairing = 9,
    NZBStateProcessingParJoin = 10,
	NZBStateProcessedPar = 11,
    NZBStateProcessingJoin = 12,
    NZBStateProcessedJoin = 13,
	NZBStateProcessingRar = 14,
	NZBStateProcessedRar = 15,
    NZBStateProcessingPostExtractPar2 = 16,
    NZBStateProcessedPostExtractPar2 = 17,
	NZBStateProcessingCleanup = 18,
	NZBStateProcessedCleanup = 19,
	NZBStateProcessingMoveToCompleted = 20,
	NZBStateProcessedMoveToCompleted = 21,
	NZBStateDone = 22,
	NZBStateUncompressError = 23,
	NZBStateParError = 24,
	NZBStateMovingToCompletedError = 25,
	NZBStateUUEncodedError = 26,
	NZBStateRemovingFromQueue = 99
} NZBState;

typedef enum {
	FileStateWaiting = 0,
	FileStateDownloading = 1,
	FileStateDownloaded = 2,
	FileStateSaving = 3,
	FileStateSaved = 4,
	FileStateSkip = 5
} FileState;

typedef enum {
	FileArticleStateWaiting = 0,
	FileArticleStateDownloading = 1,
	FileArticleStateDownloaded = 2,
	FileArticleStateDownloadFailed = 3,
	FileArticleStateSaving = 4,
	FileArticleStateSaved = 5
} FileArticleState;

typedef enum {
    QueueSortAge,
    QueueSortName,
    QueueSortSize,
    QueueSortGroupName,
    QueueSortRemainingSize
} QueueSortType;

typedef enum {
    RSSFeedTVEpisodeStateSkip,
    RSSFeedTVEpisodeStateWaiting,
    RSSFeedTVEpisodeStateDownloaded,
    RSSFeedTVEpisodeStateDownloadedRepack
} RSSFeedTVEpisodeState;


