//
//  TrialCheck.h
//  UsenetEngine
//
//  Created by Ger Teunis on 6/3/10.
//  Copyright 2010 Ger Teunis. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <UsenetEngine/Obfuscation.h>

@interface TrialCheck : NSObject {
	NSDate *trialStartDate;
	NSDate *currentDate;
	bool _shouldUpdateCurrentDate;
	bool prevWasInTrial;
	bool waitingForInitialServerDate;
	NSTimer *repeatingTimer;
	NSLock *updateCurrentDateLock;
	id mainWindowViewController;
}

@property (nonatomic, retain) NSDate* trialStartDate;
@property (nonatomic, retain) NSDate* currentDate;
@property (nonatomic) bool prevWasInTrial;
@property (nonatomic) bool waitingForInitialServerDate;
@property (nonatomic, retain) NSTimer *repeatingTimer;
@property (nonatomic, retain) NSLock *updateCurrentDateLock;
@property (nonatomic, retain) id mainWindowViewController;

#pragma mark -
#pragma mark Singleton methods
+(TrialCheck*)sharedInstance;

#pragma mark -
#pragma mark TrialCheck methods
+(bool)isInTrialPeriod;
-(int)trialDaysLeft;
-(bool)shouldUpdateCurrenteDate;
-(void)setNewCurrentDate:(NSString*)newDateStr;
-(void)setShouldUpdateCurrenteDate:(bool)value;

@end
