//
//  UsenetSearchResult.h
//  UsenetEngine
//
//  Created by Ger Teunis on 28-12-11.
//  Copyright (c) 2011 VortexApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "RSSFeedItem.h"

typedef enum {
	SearchResultClassificationOkay,
	SearchResultClassificationRisky,
	SearchResultClassificationWarning
} SearchResultClassification;

@class RSSFeedItem;

@interface UsenetSearchResult : NSObject {
	
	SearchResultClassification classification;
	NSString *classificationReason;
	bool downloaded;
	NSString *title;
	NSString *postedBy;
	NSString *downloadURL;
	NSNumber *password;
	NSNumber *fileCount;
	NSDictionary *extensions;
	NSArray *groups;
	NSNumber *hasNFO;
	NSNumber *hasRAR;
	NSNumber *parts;
	NSNumber *partsAvailable;
	NSDate *postedDate;
	NSNumber *size;
	NSNumber *par2Files;
	RSSFeedItem *rssFeedItem;
	bool par2only;
	bool useRSSDetails;
    NSArray *RARextract;
    NSString *NFOLink;
    
    bool dontAnalyse;
    bool fileAnalyse;
}

@property (nonatomic) SearchResultClassification classification;
@property (nonatomic, retain) NSString *classificationReason;
@property (nonatomic) bool downloaded;
@property (nonatomic, retain) NSString *title;
@property (nonatomic, retain) NSString *postedBy;
@property (nonatomic, retain) NSString *downloadURL;
@property (nonatomic, retain) NSNumber *password;
@property (nonatomic, retain) NSNumber *fileCount;
@property (nonatomic, retain) NSDictionary *extensions;
@property (nonatomic, retain) NSArray *groups;
@property (nonatomic, retain) NSNumber *hasNFO;
@property (nonatomic, retain) NSNumber *hasRAR;
@property (nonatomic, retain) NSNumber *parts;
@property (nonatomic, retain) NSNumber *partsAvailable;
@property (nonatomic, retain) NSDate *postedDate;
@property (nonatomic, retain) NSNumber *size;
@property (nonatomic, retain) NSNumber *par2Files;
@property (nonatomic, retain) RSSFeedItem *rssFeedItem;
@property (nonatomic) bool par2only;
@property (nonatomic) bool useRSSDetails;
@property (nonatomic, retain) NSArray *RARextract;
@property (nonatomic, retain) NSString *NFOLink;
@property (nonatomic) bool dontAnalyse;
@property (nonatomic) bool fileAnalyse;

-(void)determineClassication;

@end
